#include <jabber/jabber.h>
#include <etherx.h>
#include "yahoolib.h"

extern xmlnode yahoo_trans_config;
extern ehandler ehandler_yt;
extern int y_debug;
extern char *yt__host;
extern char *etherx__host;
extern char *etherx__secret;
extern int etherx__port;
extern ppdb PPDB;
extern ppdb y_ppdb;
extern pool main_pool;

typedef struct conference_struct
{
    pool p;
    char conf_id;
    char **user_list;
    char *host;
    struct conference_struct *next;
} _conf,*conf;

typedef struct user_list_struct
{
    pool p;
    jid j;
    xmlnode x;
    struct user_list_struct *next;
} _user_list, *user_list;

/* sessions.c */
typedef struct sessions_struct
{
    thread t;
    jid sendto;
    jid j;
    jid id;
    thread stream;
    struct yahoo_context *Con;
    int exit_flag;
    int status;
    int new_user;
    int connected;
    conf conferences;
    user_list online_users;
    struct sessions_struct *next;
    struct sessions_struct *prev;
} _session, *session;

extern struct yahoo_options Opts;
void yt_session_main(void *arg);
thread yt_session_create(char *user, char *pword, jpacket jp,int new_user);
void yt_session_end(session s);
session yt_session_find_by_jid(jid j);

/* auth.c */
int yt_auth_user(jpacket jp);
int yt_user_reg( jpacket jp );
jid yt_subscribe_auth( jid to, char *user, char *pass );
void yt_subscribe_user( jpacket jp );
void yt_unsubscribe_user( jpacket jp );
void yt_strip_jid(jid j);
int j_cmp_nores(jid a,jid b);
void yt_send_yahoo_status(session s,xmlnode x);

/* external.c */
void yt_init();
void yt_etherx_receive(epacket e);
char *str_to_UTF8(pool p,unsigned char *in);
unsigned char *UTF8_to_str(pool p,unsigned char *in);
void yt_senderror(jid j,char *code,char *errmsg);
void yt_send_message(session s,jpacket jp,char *from,char *type,char *body,char *subject);
void yt_send_presence(session s,jpacket jp,char *from,char *type,char *status,char *show);

/* config.c */
int yt_load_config(char* ConfigFile);

/* control.c */
int yt_trans_stop(void);

/* parser.c */
int yt_parse_packet(jpacket jp);

/* filetransfer.c */

/* groupchat.c */
typedef struct conf_struct
{
        char *conf_id;
	char **userlist;
        int type; //0 - normal, 1 - voice
	struct conf_struct *next;
} _conference, *conference;
void groupchat_handle_invite(struct yahoo_packet *pkt,session s);
void groupchat_handle_message(struct yahoo_packet *pkt,session s);
void groupchat_send_invite(jpacket jp, session s);
void groupchat_send_message(jpacket jp,session s,char *msg);
void groupchat_logon(jpacket jp,session s);
void gropuchat_decline(jpacket jp,session s);
void groupchat_logoff(jpacket jp,session s);
conference groupchat_start_conf(session s,char *conf_id);
