/*
Yahoo-Transport control.c Handles stopping the transport
Copyright (C) 1999-2000 Keith Minkler <tsbandit@jabber.org>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You can reach The author at tsbandit@jabber.org (email or jid)
*/

#include <yahootrans.h>
extern session sessions;
/* XXX This file will deal with transport control (mainly clean stops) */

/*
log all users out, and send a nice message
*/
int yt_trans_stop(void)
{
    session loop=sessions;
    while(loop!=NULL)
    {
        xmlnode message;
        message=xmlnode_new_tag("message");
        xmlnode_put_attrib(message,"from",yt__host);
        xmlnode_put_attrib(message,"type","error");
        xmlnode_put_attrib(message,"to",jid_full(loop->sendto));
        xmlnode_insert_cdata(xmlnode_insert_tag(message,"error"),"Yahoo transport shutting down.",-1);
        xmlnode_put_attrib(xmlnode_get_tag(message,"error"),"code","502");
        ehandler_send(ehandler_yt,message,loop->sendto->server);
        if(loop->exit_flag!=1)
        {
            log_error(ZONE,"[YAHOO] (%s) still active telling to quit.",jid_full(loop->j));
            loop->exit_flag=1;
            session_unlink(loop);
        }
        loop=loop->next;
    }
    return 0;
}
