/*
Yahoo-Transport groupchat.c functions for groupchat sub agent
Copyright (C) 1999-2000 Keith Minkler <tsbandit@jabber.org>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You can reach The author at tsbandit@jabber.org (email or jid)
*/

#include "yahootrans.h"

/*
provides the sub-agent response 
*/
void groupchat_agent_request(jpacket jp)
{
    xmlnode iq,query,agent,name,description,service;
    spool s;
    if(jp==NULL) return;

    s=spool_new(jp->p);
    jutil_iqresult(jp->x);
    query=xmlnode_insert_tag(jp->x,"query");
    xmlnode_put_attrib(query,"xmlns","jabber:iq:agents");
    agent=xmlnode_insert_tag(query,"agent");
    spooler(s,"conf.",yt__host,s);
    xmlnode_put_attrib(agent,"jid",spool_print(s));
    name=xmlnode_insert_tag(agent,"name");
    xmlnode_insert_cdata(name,"Yahoo Conferencing",-1);
    description=xmlnode_insert_tag(agent,"description");
    xmlnode_insert_cdata(description,"Yahoo Conferencing support",-1);
    service=xmlnode_insert_tag(agent,"service");
    xmlnode_insert_cdata(service,"groupchat",-1);
    jpacket_reset(jp);   
    ehandler_send(ehandler_yt,jp->x,jp->to->server);
}

/*
sends an invite message to jabber user
*/
void groupchat_handle_invite(struct yahoo_packet *pkt,session s)
/*
    pkt->conf_id   -- id of the conference
    pkt->conf_host --  who is hosting the conference
    pkt->conf_user -- single username ( used in declined conference/addinvite/message/logon/logoff
    pkt->conf_userlist -- user list
    pkt->conf_inviter -- user who invited you
    pkt->conf_msg -- conference message
    pkt->conf_type -- text(0) or voice(1) conference
*/
{
    xmlnode message,body;
    pool p=pool_new();
    spool sp=spool_new(p);
    spool sq=spool_new(p);
    if(pkt==NULL||s==NULL) return;
       
    message=xmlnode_new_tag("message");
    xmlnode_put_attrib(message,"to",jid_full(s->sendto));
    spooler(sp,pkt->conf_id,"@conf.",yt__host,sp);
    xmlnode_put_attrib(message,"from",spool_print(sp));
    xmlnode_put_attrib(message,"type","groupchat");
    body=xmlnode_insert_tag(message,"body");
    spooler(sq,pkt->conf_inviter,", Who is in a Yahoo conference, has invited to you join this Yahoo conference: ",pkt->conf_msg,sq);
    xmlnode_insert_cdata(body,spool_print(sq),-1);
    ehandler_send(ehandler_yt,message,s->sendto->server);
    /* XXX we should be adding this conference to the session, so that replies go to the right spot. */
    pool_free(p);
}

/*
messages from yahoo conference get sent groupchat to jabber
*/
void groupchat_handle_message(struct yahoo_packet *pkt,session s)
{
    xmlnode message,body;
    pool p=pool_new();
    spool sp=spool_new(p);
    if(pkt==NULL||s==NULL) return;
    
    message=xmlnode_new_tag("message");
    xmlnode_put_attrib(message,"to",jid_full(s->sendto));
    spooler(sp,pkt->conf_id,"@conf.",yt__host,"/",pkt->conf_user,sp);
    xmlnode_put_attrib(message,"from",spool_print(sp));
    xmlnode_put_attrib(message,"type","groupchat");
    body=xmlnode_insert_tag(message,"body");
    xmlnode_insert_cdata(body,pkt->conf_msg,-1);
    ehandler_send(ehandler_yt,message,s->sendto->server);
    pool_free(p);
}

void groupchat_send_invite(jpacket jp, session s)
{
}

void groupchat_send_message(jpacket jp,session s,char *msg)
{
}

void groupchat_logon(jpacket jp,session s)
{
}

void gropuchat_decline(jpacket jp,session s)
{
}

void groupchat_logoff(jpacket jp,session s)
{
}

conference groupchat_start_conf(session s,char *conf_id)
{
    return NULL;
}
